# R Breakpoints

A breakpoint suspends the execution of the R code at the location where the breakpoint is set.

Breakpoints are displayed in the vertical editor ruler and in the Breakpoints view.

### Overview of Breakpoint Properties and their Icons

| (blue circle) | Enabled breakpoint
| (blank circle) | Disabled breakpoint
| (strike out) | Disabled by Skip All Breakpoints
| (question mark) | Conditional breakpoint
| (arrow right) | Hit Function entry (method breakpoint)
| (arrow left) | Hit Function exit (method breakpoint)
| (prompt) | Toplevel breakpoint
| (exclamation mark) | Error breakpoint
| (checkmark) | Installed breakpoint

## Types

StatET provides the following types of breakpoints:

- R Line Breakpoint
- R Method Breakpoint
- R Error Breakpoint

## Properties

All properties of a breakpoints can be edited in the Breakpoints view. Note that the detail pane showing the breakpoint properties directly in the view is not visible when the Layout of the view is set to Breakpoints Only; if required, change the layout of the Breakpoint view to another option in its view menu. Some properties are also accessible in the context menu of breakpoints, if they are shown for example in the editor ruler.

In contrast to adding/removing a breakpoint, property changes takes effect immediately at any time, even the code is already running.

Common properties:

- Enabled / Disabled
- Condition